/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * ưǥȵǽ
 */

/*
 * Cmemo : Text Editor
 * auto_indent.c - source file for auto indentation
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "undo.h"
#include "ini_file.h"
#include "auto_indent.h"


/**************************
   ʰ׼ưǥȵǽ
 **************************/
/* Control Key򲡤ʤReturn Key򲡤ȥǥȤʤ */
/* Ctrl+MǼưǥ Shift+Ctrl+Mǥǥ̵       */
void auto_indent_cb(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gpointer focused_widget;
  GdkEventKey *kevent = (GdkEventKey *)event;
  unsigned int pos;
  unsigned char *line_text;
  unsigned char *line_start;
  unsigned int indent_count;
  unsigned char indent_char[256];


  /* 硼ȥåȥǽλ褦Ȥȥ顼å */
  /* ФΤǡ򤹤ե饰å         */
  if (cm_end_flag == 1) {
    return;
  }

  /*եΤ륦ɥΥݥ󥿤򥻥å*/
  if (GTK_WIDGET_HAS_FOCUS((GtkWidget *)current_document->textbox) == 1) {
    focused_widget = current_document->textbox;
  }
  else {
    return;
  }

  /* Ctrl+Mǲ */
  /* (kevent->state == 1)  : Shift          */
  /* (kevent->state == 4)  : Ctrl           */
  /* (kevent->state == 8)  : Alt            */
  /* (kevent->state == 5)  : Shift+Ctrl     */
  /* (kevent->state == 9)  : Shift+Alt      */
  /* (kevent->state == 12) : Ctrl+Alt       */
  /* (kevent->state == 13) : Shift+Ctrl+Alt */
  if ((kevent->state == 4) || (kevent->state == 5)) {
    if ((kevent->keyval == GDK_M) ||(kevent->keyval == GDK_m)) {
      pos = gtk_editable_get_position(GTK_EDITABLE(focused_widget));
      /* 󥵡ȥ٥ȤʤΤǶŪundoХåեϿ */
      doc_insert_text_cb (GTK_EDITABLE(focused_widget), "\n",
                          strlen("\n"), &pos, (gpointer)current_document);
      /* ֹɽѥǡ */
      line_count_insert(GTK_EDITABLE(focused_widget),
                        "\n", strlen("\n"), &pos, NULL);
      gtk_text_insert(GTK_TEXT(focused_widget), cm_normal_font,
                      &cm_base_color, NULL, "\n", strlen("\n"));
      if (kevent->state == 5) {
        return;
      }
    }
  }

  /* ưǥOFFξϴؿȴ */
  if (cm_indent_mode == 0) {
    return;
  }

/*debug*/
/*g_print("state = %d\n", kevent->state);*/
/*g_print("keyval = %d\n", kevent->keyval);*/

  /* ⤷ Ctrl+Return Ƥ鼫ưǥ */
  /* Ԥ鷺˲Ԥƴؿȴ褦ˤ    */
  if (kevent->state == 4) {
    if (kevent->keyval == GDK_Return) {
      pos = gtk_editable_get_position(GTK_EDITABLE(focused_widget));
      /*󥵡ȥ٥ȤʤΤǶŪundoХåեϿ*/
      doc_insert_text_cb (GTK_EDITABLE(focused_widget), "\n",
                          strlen("\n"), &pos, (gpointer)current_document);
      /*ֹɽѥǡ*/
      line_count_insert(GTK_EDITABLE(focused_widget),
                        "\n", strlen("\n"), &pos, NULL);
      gtk_text_insert(GTK_TEXT(focused_widget), cm_normal_font,
                      &cm_base_color, NULL, "\n", strlen("\n"));
      return;
    }
    /* Ctrl+OcannaưƤޤ */
    /*else if (kevent->keyval == GDK_O) {
      open_text(NULL, focused_widget);
    }*/
  }

  if ((kevent->keyval == GDK_Return) ||
      ((kevent->state == 4) && 
      ((kevent->keyval == GDK_M) ||(kevent->keyval == GDK_m)))) {
    pos = gtk_editable_get_position(GTK_EDITABLE(focused_widget));
    if (pos > 256) {
      line_text = gtk_editable_get_chars(GTK_EDITABLE(focused_widget),
                                         pos - 256, pos - 1);
    }
    else {
      line_text = gtk_editable_get_chars(GTK_EDITABLE(focused_widget), 0, pos - 1);
    }
/*debug*/
/*g_print("pos %d\n", pos);*/

    if (line_text != NULL) {
      line_start = strrchr(line_text, (int)'\n');
    }
    else {
      /*free(line_text);*/
      return;
    }

    if (line_start != NULL) {
      line_start++;
    }
    else {
      line_start = line_text;
    }
/*debug*/
/*g_print("line_text %s\n", line_start);*/

    indent_count = 0;
    memset(&indent_char[0], 0, sizeof(indent_char));
    while (((int)line_start[indent_count] == (int)' ') ||
           ((int)line_start[indent_count] == (int)'\t')) {
      indent_count++;
    }
    if (indent_count >= 256) {
      indent_count = 256 - 1;
    }
    memcpy(&indent_char[0], line_start, indent_count);

    if (indent_count != 0) {
      /* 󥵡ȥ٥ȤʤΤǶŪundoХåեϿ */
      doc_insert_text_cb (GTK_EDITABLE(focused_widget), &indent_char[0],
                          indent_count, &pos, (gpointer)current_document);
      /* ֹɽѥǡ */
      line_count_insert(GTK_EDITABLE(focused_widget),&indent_char[0],
                        indent_count, &pos, NULL);
      gtk_text_insert(GTK_TEXT(focused_widget), cm_normal_font,
                      &cm_base_color, NULL, &indent_char[0], indent_count);
    }
    free(line_text);
  }

  return;
}
