/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * ե(~/.cmemo)ɤ߹ߤ˴ؤؿ
 */

/*
 * Cmemo : Text Editor
 * ini_file.c - source file for loading ~/.cmemo
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include "cme_def.h"
#include "cmemo.h"
#include "files.h"
#include "ini_file.h"
#include "interface.h"
#include "search.h"
#include "cme_misc.h"


/* ----- ѿ -------------------  ---------------------  -------- */
unsigned int cm_window_width;  /* ưΥɥ   : width         */
unsigned int cm_window_height; /* ưΥɥι⤵ : height        */
char cm_key_font[256];         /* ɤΥե     : key_font      */
char cm_text_font[256];        /* ɰʳΥե : text_font     */
unsigned int cm_tab_width;     /*                    : tab_width     */
unsigned int cm_indent_mode;   /* auto indent 0:don't 1:do : indent_on_off */
GdkColor cm_base_color;        /* ١顼             : base_color    */
GdkColor cm_key1_color;        /* ɥ顼       : key1_color    */
GdkColor cm_key2_color;        /* ɥ顼       : key2_color    */
GdkColor cm_number_color;      /* ͥ顼               : num_color     */
GdkColor cm_comment_color;     /* ȥ顼           : cmt_color     */
GdkColor cm_string_color;      /* ʸ󥫥顼             : str_color     */
/* ----------------------------------------------------------------------- */
char cm_home_path[MAX_PATH];   /* ۡǥ쥯ȥؤΥѥ */

static char dotcmemo_path[MAX_PATH]; /* .cmemoؤΥѥ */
static char dotcmemodb_path[MAX_PATH]; /* .cmemodbؤΥѥ */
static char file_line_buf[FILE_LINE_BUF_SIZE];
/* global searchcomboboxΥꥹȿ : gsearch_history_count */
static unsigned int combo_list_count = 10; /* ǥեȤ10 */

/* local declarations */
int read_file_buf(struct file_buf *start, FILE *fp);
int write_file_buf(struct file_buf *start, FILE *fp);
int free_file_buf(struct file_buf *start);
void read_combo_list(char *key, int max, GList **m_glist);
void write_combo_list(char *key, int max, GList **m_glist);
int read_keyword_def(FILE *fp);


/**********************************
   Ƽѥ򥰥Хѿ˳Ǽ
 **********************************/
int init_path_data(void)
{
  char *pini_path;      /*getenvͤǼݥ*/

  pini_path = getenv("HOME");
  if (pini_path == NULL) {
    printf("fail to get environment value. (HOME)\n");
    return(-1);
  }

  /* ĶѿHOME */
  /* '/'դʤ褦Ǥ */
  if (strlen(pini_path) < sizeof(cm_home_path)) {
    strcpy(cm_home_path, pini_path);
    /* Ϥˤägetenvfree餷 */
    /* ؿ(init_path_data)cmemo¹Ի1ٸƤФǤ */
    /* ⤷getenvmallocƤƤcmemoλˤΰ  */
    /* OS֤롣ޤݤΰϤۤ礭ʤΤǤ */
    /* ʤäơǤfreeʤȤȤ롣               */
    /*free(pini_path);*/
  }
  else {
    /* Ϥˤägetenvfree餷 */
    /* ؿ(init_path_data)cmemo¹Ի1ٸƤФǤ */
    /* ⤷getenvmallocƤƤcmemoλˤΰ  */
    /* OS֤롣ޤݤΰϤۤ礭ʤΤǤ */
    /* ʤäơǤfreeʤȤȤ롣               */
    /*free(pini_path);*/
    memset(cm_home_path, 0, sizeof(cm_home_path));
    printf("too long home directory name.\n");
    return(-1);
  }

  /* ĶѿHOME"/.cmemo"Ĥʤ */
  if ((strlen(cm_home_path) + strlen(DOT_CMEMO)) < sizeof(dotcmemo_path)) {
    sprintf(dotcmemo_path, "%s%s", cm_home_path, DOT_CMEMO);
  }
  else {
    memset(dotcmemo_path, 0, sizeof(dotcmemo_path));
    printf("too long ~/.cmemo name.\n");
    return(-1);
  }

  /* ĶѿHOME"/.cmemodb"Ĥʤ */
  if ((strlen(cm_home_path) + strlen(DOT_CMEMODB)) < sizeof(dotcmemodb_path)) {
    sprintf(dotcmemodb_path, "%s%s", cm_home_path, DOT_CMEMODB);
  }
  else {
    memset(dotcmemodb_path, 0, sizeof(dotcmemodb_path));
    printf("too long ~/.cmemodb name.\n");
    return(-1);
  }

  return(0);
}

/**************************************
   file_buf˥եƤɤ߹
 **************************************/
int read_file_buf(struct file_buf *start, FILE *fp)
{
  struct file_buf *cur_line;
  char buf[1024];

  cur_line = start;
  memset(cur_line, 0, sizeof(struct file_buf));
  cur_line->line_num = 1;
  rewind(fp);
  while (fgets(buf, sizeof(buf), fp) != NULL) {
    cur_line->line_buf = (char *)malloc(strlen(buf) + 1);
    if (cur_line->line_buf != NULL) {
      strcpy(cur_line->line_buf, buf);
      cur_line->next = (struct file_buf *)malloc(sizeof(struct file_buf));
      if (cur_line->next == NULL) {
        free_file_buf(start);
        return(-1);
      }
      memset(cur_line->next, 0, sizeof(struct file_buf));
      (cur_line->next)->prev = cur_line;
      (cur_line->next)->line_num = cur_line->line_num + 1;
      cur_line = cur_line->next;        
    }
    else {
      free_file_buf(start);
      return(-1);
    }
  }
  return(0);
}

/**************************************
   file_bufƤե˽񤭹
 **************************************/
int write_file_buf(struct file_buf *start, FILE *fp)
{
  struct file_buf *cur_line;

  cur_line = start;
  while (cur_line != NULL) {
    /* Хåեݥ󥿤NULLǤʤ */
    if (cur_line->line_buf != NULL) {
      /* ХåեƬʸʥ뽪üʸǤʤн񤭹 */
      if (*(cur_line->line_buf) != '\0') {
        fputs(cur_line->line_buf, fp);
      }
    }
    cur_line = cur_line->next;
  }
  return(0);
}

/********************************
   file_buf
 ********************************/
int free_file_buf(struct file_buf *start)
{
  struct file_buf *cur_line;
  struct file_buf *tmp;

  cur_line = start;
  while (cur_line != NULL) {
    /* debug */
    /*printf("%s", cur_line->line_buf);*/
    /*printf("%x\n", cur_line->line_buf);*/
    tmp = cur_line->next;
    free(cur_line->line_buf);
    free(cur_line);
    cur_line = tmp;
  }
  return(0);
}

/******************************************
   ɤ߹GkdColor˥åȤ
 ******************************************/
int set_color(GdkColor *color, char *pref)
{
  char shubetu[256];
  char buf[256];
  char *comma_pos;

  /*  */
  memset(&buf[0], 0, sizeof(buf));
  strcpy(&buf[0], "0x0000,0x0000,0x0000");

  /* ǡ */
  sscanf(pref, "%s %s", &shubetu[0], &buf[0]);

  /* red green blue  unsigned short ʤΤˤäƤϤդ뤫 */
  comma_pos = &buf[0];

  /*  */
  color->red = strtol(comma_pos, NULL, 0);

  /*  */
  if ((comma_pos = strchr(comma_pos, ',')) != NULL) {
    comma_pos++;
    color->green = strtol(comma_pos, NULL, 0);

    /*  */
    if ((comma_pos = strchr(comma_pos, ',')) != NULL) {
      comma_pos++;
      color->blue = strtol(comma_pos, NULL, 0);
    }
    else {
      color->blue = 0;
    }
  }
  else {
    color->green = 0;
    color->blue = 0;
  }
  /* debug */
  /*printf("r:%d\ng:%d\nb:%d\n",color->red,color->green,color->blue);*/
  return(0);
}

/****************************
   ɤ߹
 ****************************/
int read_keyword_def(FILE *fp)
{
  char pref[INI_LINE_LEN];    /* ե~/.cmemoΣԣԤǼХåե */
  char shubetu[INI_LINE_LEN]; /* pref[]ΣĤΥȡǼХåե */
  char tmp_buf[INI_LINE_LEN];
  int i;

  if (fp == NULL) {
    /* ʤϤ */
    return(-1);
  }

  i = 0;
  memset(&cm_ft_inf[i], 0, sizeof(cm_ft_inf[i]));
  cm_ft_inf[i].data_flag = 1;
  cm_ft_inf[i].mode_id = i;
  strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  /* debug */
  /*printf("sizeof(cm_ft_inf)    %6d bytes\n", sizeof(cm_ft_inf));*/
  /*printf("sizeof(cm_ft_inf[i]) %6d bytes\n", sizeof(cm_ft_inf[i]));*/

  memset(pref, 0, sizeof(pref));
  while (fgets(pref, sizeof(pref), fp) != NULL) {
    memset(shubetu, 0, sizeof(shubetu));
    sscanf(pref, "%s", shubetu);

    /*եιܤμ̤ˤäƽʬ*/
    if (strcmp(shubetu, "kdef_enabled") == 0) {
      sscanf(pref, "%s %d", shubetu, &cm_ft_inf[i].enabled);
    }
    else if (strcmp(shubetu, "kdef_ignore_case") == 0) {
      sscanf(pref, "%s %d", shubetu, &cm_ft_inf[i].ignore_case);
    }
    else if (strcmp(shubetu, "kdef_base_color") == 0) {
      set_color(&cm_ft_inf[i].base_color, &pref[0]);
    }
    else if (strcmp(shubetu, "kdef_key1_color") == 0) {
      set_color(&cm_ft_inf[i].key1_color, &pref[0]);
    }
    else if (strcmp(shubetu, "kdef_key2_color") == 0) {
      set_color(&cm_ft_inf[i].key2_color, &pref[0]);
    }
    else if (strcmp(shubetu, "kdef_num_color") == 0) {
      set_color(&cm_ft_inf[i].num_color, &pref[0]);
    }
    else if (strcmp(shubetu, "kdef_cmt_color") == 0) {
      set_color(&cm_ft_inf[i].cmt_color, &pref[0]);
    }
    else if (strcmp(shubetu, "kdef_str_color") == 0) {
      set_color(&cm_ft_inf[i].str_color, &pref[0]);
    }
    else {
      memset(tmp_buf, 0, sizeof(tmp_buf));
      sscanf(pref, "%s %s", shubetu, tmp_buf);
      if (strcmp(shubetu, "kdef_title") == 0) {
        if (strlen(tmp_buf) < sizeof(cm_ft_inf[i].title))
          strcpy(cm_ft_inf[i].title, tmp_buf);
        else {
          strncpy(cm_ft_inf[i].title, tmp_buf, sizeof(cm_ft_inf[i].title) - 1);
        }
      }
      else if (strcmp(shubetu, "kdef_mode") == 0) {
        if (strlen(tmp_buf) < sizeof(cm_ft_inf[i].mode))
          strcpy(cm_ft_inf[i].mode, tmp_buf);
        else {
          strncpy(cm_ft_inf[i].mode, tmp_buf, sizeof(cm_ft_inf[i].mode) - 1);
        }
      }
      else if (strcmp(shubetu, "kdef_ext") == 0) {
        if (strlen(tmp_buf) < sizeof(cm_ft_inf[i].ext))
          strcpy(cm_ft_inf[i].ext, tmp_buf);
        else {
          strncpy(cm_ft_inf[i].ext, tmp_buf, sizeof(cm_ft_inf[i].ext) - 1);
        }
      }
      else if (strcmp(shubetu, "kdef_key1buf") == 0) {
        if (strlen(tmp_buf) < sizeof(cm_ft_inf[i].key1buf))
          strcpy(cm_ft_inf[i].key1buf, tmp_buf);
        else {
          strncpy(cm_ft_inf[i].key1buf, tmp_buf, sizeof(cm_ft_inf[i].key1buf) - 1);
        }
      }
      else if (strcmp(shubetu, "kdef_key2buf") == 0) {
        if (strlen(tmp_buf) < sizeof(cm_ft_inf[i].key2buf))
          strcpy(cm_ft_inf[i].key2buf, tmp_buf);
        else {
          strncpy(cm_ft_inf[i].key2buf, tmp_buf, sizeof(cm_ft_inf[i].key2buf) - 1);
        }
      }
      else if (strcmp(shubetu, "kdef_cmt_start") == 0) {
        if (strlen(tmp_buf) < sizeof(cm_ft_inf[i].cmt_start))
          strcpy(cm_ft_inf[i].cmt_start, tmp_buf);
        else {
          strncpy(cm_ft_inf[i].cmt_start, tmp_buf, sizeof(cm_ft_inf[i].cmt_start) - 1);
        }
      }
      else if (strcmp(shubetu, "kdef_cmt_end") == 0) {
        if (strlen(tmp_buf) < sizeof(cm_ft_inf[i].cmt_end))
          strcpy(cm_ft_inf[i].cmt_end, tmp_buf);
        else {
          strncpy(cm_ft_inf[i].cmt_end, tmp_buf, sizeof(cm_ft_inf[i].cmt_end) - 1);
        }
      }
      else if (strcmp(shubetu, "kdef_line_cmt") == 0) {
        if (strlen(tmp_buf) < sizeof(cm_ft_inf[i].line_cmt))
          strcpy(cm_ft_inf[i].line_cmt, tmp_buf);
        else {
          strncpy(cm_ft_inf[i].line_cmt, tmp_buf, sizeof(cm_ft_inf[i].line_cmt) - 1);
        }
      }
      else if (strcmp(shubetu, "kdef_acckey") == 0) {
        cm_ft_inf[i].acckey = tmp_buf[0];
      }
      else if (strcmp(shubetu, "kdef_str_start") == 0) {
        cm_ft_inf[i].str_start = tmp_buf[0];
      }
      else if (strcmp(shubetu, "kdef_str_end") == 0) {
        cm_ft_inf[i].str_end = tmp_buf[0];
      }
      else if (strcmp(shubetu, "kdef_chr_start") == 0) {
        cm_ft_inf[i].chr_start = tmp_buf[0];
      }
      else if (strcmp(shubetu, "kdef_chr_end") == 0) {
        cm_ft_inf[i].chr_end = tmp_buf[0];
      }
      else if (strcmp(shubetu, "kdef_esc_chr") == 0) {
        cm_ft_inf[i].esc_chr = tmp_buf[0];
      }
      else if (strcmp(shubetu, "KEYWORD_DEFINE") == 0) {
        if (strcmp(tmp_buf, "NEXT") == 0) {
          i++;
          if (i >= FTYPE_INFO_MAX) {
            break;
          }
          else {
            memset(&cm_ft_inf[i], 0, sizeof(cm_ft_inf[i]));
            cm_ft_inf[i].data_flag = 1;
            cm_ft_inf[i].mode_id = i;
            strcpy(cm_ft_inf[i].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
          }
        }
        else if (strcmp(tmp_buf, "END") == 0) {
          break;
        }
      }
      else if (strcmp(shubetu, "#end!!") == 0) {
        return(1);
      }
    }
    memset(&pref[0], 0, sizeof(pref));
  }
  return(0);
}

/**************************
   եɤ߹
 **************************/
int read_ini(void)
{
  FILE *fp;
  char pref[INI_LINE_LEN];    /* ե~/.cmemoΣԣԤǼХåե */
  char shubetu[INI_LINE_LEN]; /* pref[]ΣĤΥȡǼХåե */
  char tmp_buf[INI_LINE_LEN];
  int rtn;

  /*Хѿʤɤ*/
  cm_window_width = 0;
  cm_window_height = 0;
  memset(&cm_key_font[0], 0, sizeof(cm_key_font));
  memset(&cm_text_font[0], 0, sizeof(cm_text_font));
  cm_tab_width = 0;
  combo_list_count = 10;

  memset(&pref[0], 0, sizeof(pref));
  /*fgetsΤ˳"r"(ƥ)ǳ*/
  if ((fp = fopen(dotcmemo_path, "r")) != NULL) {
    /* textեιԥХåե󥰤Ԥ */
    if (setvbuf(fp, file_line_buf, _IOLBF, sizeof(file_line_buf)) != 0) {
      fclose(fp);
      perror("setvbuf");
      return(-1);
    }
    rewind(fp);
    while (fgets(pref, sizeof(pref), fp) != NULL) {
      memset(&shubetu[0], 0, sizeof(shubetu));
      sscanf(pref, "%s", shubetu);

      /*եιܤμ̤ˤäƽʬ*/
      if (strcmp(shubetu, "width") == 0) {
        sscanf(pref, "%s %u", shubetu, &cm_window_width);
      }
      else if (strcmp(shubetu, "height") == 0) {
        sscanf(pref, "%s %u", shubetu, &cm_window_height);
      }
      else if (strcmp(shubetu, "key_font") == 0) {
        sscanf(pref, "%s %s", shubetu, &cm_key_font[0]);
      }
      else if (strcmp(shubetu, "text_font") == 0) {
        sscanf(pref, "%s %s", shubetu, &cm_text_font[0]);
      }
      else if (strcmp(shubetu, "tab_width") == 0) {
        sscanf(pref, "%s %u", shubetu, &cm_tab_width);
      }
      else if (strcmp(shubetu, "indent_on_off") == 0) {
        sscanf(pref, "%s %u", shubetu, &cm_indent_mode);
      }
      else if (strcmp(shubetu, "base_color") == 0) {
        set_color(&cm_base_color, &pref[0]);
      }
      else if (strcmp(shubetu, "key1_color") == 0) {
        set_color(&cm_key1_color, &pref[0]);
      }
      else if (strcmp(shubetu, "key2_color") == 0) {
        set_color(&cm_key2_color, &pref[0]);
      }
      else if (strcmp(shubetu, "num_color") == 0) {
        set_color(&cm_number_color, &pref[0]);
      }
      else if (strcmp(shubetu, "cmt_color") == 0) {
        set_color(&cm_comment_color, &pref[0]);
      }
      else if (strcmp(shubetu, "str_color") == 0) {
        set_color(&cm_string_color, &pref[0]);
      }
      else if (strcmp(shubetu, "def_ignore_case") == 0) {
        sscanf(pref, "%s %u", shubetu, &cm_ignore_case);
      }
      else if (strcmp(shubetu, "gsearch_history_count") == 0) {
        sscanf(pref, "%s %u", shubetu, &combo_list_count);
      }
      else if (strcmp(shubetu, "KEYWORD_DEFINE") == 0) {
        sscanf(pref, "%s %s", shubetu, &tmp_buf[0]);
        if (strcmp(tmp_buf, "START") == 0) {
          rtn = read_keyword_def(fp);
          if (rtn == 1) {
            break;
          }
          else if (rtn == -1) {
            /* ʤϤ */
            fclose(fp);
            return(0);
          }
        }
      }
      else if (strcmp(shubetu, "#end!!") == 0) {
        break;
      }
      memset(&pref[0], 0, sizeof(pref));
    }
    fclose(fp);
  }
  return(0);
}

/*****************************
   եcmemoǳ
 *****************************/
int show_ini(GtkWidget *widget, gpointer data)
{
  char command[1024]; /*ޥɥ饤Ϥʸ*/

  if (strlen(cm_home_path) != 0) {
    sprintf(command, "cmemo %s/.cmemo &", cm_home_path);
    system(command);
  }
  else {
    mlwrite("can\'t find ~/.cmemo", 0);
  }
  return(0);
}

/*****************************
   cmemodbե򹹿
 *****************************/
int update_cmemodb(char *key, int key_len, char *data)
{
  FILE *fp;
  char buf[1024];
  int flag;
  struct file_buf *top_line;
  struct file_buf *cur_line;


  /* ꤵ줿ܤäɤΥե饰 */
  flag = 0;

  top_line = (struct file_buf *)malloc(sizeof(struct file_buf));
  if (top_line == NULL) {
    return(-1);
  }
  memset(top_line, 0, sizeof(struct file_buf));

  /* cmemodb */
  if ((fp = fopen(dotcmemodb_path, "r")) != NULL) {
    /* textեιԥХåե󥰤Ԥ */
    if (setvbuf(fp, file_line_buf, _IOLBF, sizeof(file_line_buf)) != 0) {
      fclose(fp);
      perror("setvbuf");
      return(-1);
    }
    rewind(fp);
    if (read_file_buf(top_line, fp) == -1) {
      /* read_file_buf˼ԤϥƳƤä */
      fclose(fp);
      return(-1);
    }
    fclose(fp);
  }
  /* cmemodb̵ */
  else {
    sprintf(buf, "%s %s\n", key, data);
    top_line->line_buf = (char *)malloc(strlen(buf) + 1);
    if (top_line->line_buf != NULL) {
      strcpy(top_line->line_buf, buf);
    }
    else {
      return(-1);
    }
  }

  cur_line = top_line;
  while (cur_line != NULL) {
    /* Хåեݥ󥿤NULLǤʤ */
    if (cur_line->line_buf != NULL) {
      if (strncmp(cur_line->line_buf, key, key_len) == 0) {
        /* dataʸξ礽ιԤ */
        if (strlen(data) == 0) {
          *(cur_line->line_buf) = '\0';
          flag = 1;
          break;
        }
        sprintf(buf, "%s %s\n", key, data);
        /* cur_line->line_buf˳ݤƤХåեĹ */
        /* ǼʸĹ+ʥ뽪üʸʬǤ        */
        if (strlen(cur_line->line_buf) >= strlen(buf) + 1) {
          strcpy(cur_line->line_buf, buf);
        }
        else {
          /* bufʸĹϥݤľ */
          free(cur_line->line_buf);
          cur_line->line_buf = (char *)malloc(strlen(buf) + 1);
          if (cur_line->line_buf != NULL) {
            strcpy(cur_line->line_buf, buf);
          }
          else {
            return(-1);
          }
        }
        flag = 1;
        break;
      }
    }
    cur_line = cur_line->next;
  }

  if ((fp = fopen(dotcmemodb_path, "w")) != NULL) {
    write_file_buf(top_line, fp);
    /* Ȥä곫 */
    free_file_buf(top_line);
    fclose(fp);
  }
  else {
    free_file_buf(top_line);
    return(-1);
  }

  if (flag == 0) {
    if ((fp = fopen(dotcmemodb_path, "a")) != NULL) {
      sprintf(buf, "%s %s\n", key, data);
      fputs(buf, fp);
      fclose(fp);
    }
    else {
      /* ޤƤtop_lineϴ˳Ƥ */
      /*free_file_buf(top_line);*/
      return(-1);
    }
  }

  return(0);
}

/*************************************
   cmemodbեΥǡɤ߹
 *************************************/
int read_cmemodb(char *key, int key_len, char *rtn_buf)
{
  FILE *fp;
  char buf[1024];
  char dummy[1024];

  if ((fp = fopen(dotcmemodb_path, "r")) != NULL) {
    /* textեιԥХåե󥰤Ԥ */
    if (setvbuf(fp, file_line_buf, _IOLBF, sizeof(file_line_buf)) != 0) {
      fclose(fp);
      perror("setvbuf");
      return(-1);
    }
    rewind(fp);
    while (fgets(buf, sizeof(buf), fp) != NULL) {
      if (strncmp(buf, key, key_len) == 0) {
        sscanf(buf, "%s %s", dummy, rtn_buf);
        fclose(fp);
        return(0);
      }
    }
    fclose(fp);
  }
  else {
    printf("%s\n", FAIL_TO_OPEN_CMEMODB);
    return(-1);
  }

  return(-1);
}

/********************************************
   ܥܥåΥꥹȤ˥ǡɤ߹
 ********************************************/
void read_combo_list(char *key, int max, GList **m_glist)
{
  char key_buf[256];
  char buf[256];
  int i;
  char *data;

  for (i = 0; i < max; i++) {
    sprintf(&key_buf[0], "%s%d", key, i);
    if (read_cmemodb(&key_buf[0], strlen(&key_buf[0]), &buf[0]) != -1) {
      data = (char *)malloc(strlen(&buf[0]) + 1);
      strcpy(data, &buf[0]);
      *m_glist = g_list_append(*m_glist, data);
    }
  }
  return;
}

/**********************************
   ܥܥåΥǡ
 **********************************/
void init_combo_list(void)
{
  if (combo_list_count == 0) {
    combo_list_count = 10;
  }
  read_combo_list("DIRLIST", combo_list_count, &cm_dir.glist);
  read_combo_list("FTYPELIST", combo_list_count, &cm_ftype.glist);
  read_combo_list("PATLIST", combo_list_count, &cm_pat.glist);

  return;
}

/*****************************************************
   ܥܥåΥꥹȤΥǡcmemodb˽񤭹
 *****************************************************/
void write_combo_list(char *key, int max, GList **m_glist)
{
  char key_buf[256];
  int i;
  GList *tmp;

  /* ޤglistƬ˰ư */
  tmp = *m_glist;
  tmp = g_list_first(tmp);

  i = 0;
  while (tmp != NULL) {
    if (tmp->data != NULL) {
      sprintf(&key_buf[0], "%s%d", key, i);
      if (update_cmemodb(&key_buf[0], strlen(&key_buf[0]), tmp->data) != -1) {
        i++;
      }
      if (i > max) {
        break;
      }
    }
    tmp = g_list_next(tmp);
  }
  return;
}

/************************************
   ܥܥåΥǡ񤭽Ф
 ************************************/
void write_combo_list_data(void)
{
  if (combo_list_count == 0) {
    combo_list_count = 10;
  }
  /* ܥܥåΥǡ񤭽Ф */
  write_combo_list("DIRLIST", combo_list_count, &cm_dir.glist);
  write_combo_list("FTYPELIST", combo_list_count, &cm_ftype.glist);
  write_combo_list("PATLIST", combo_list_count, &cm_pat.glist);

  return;
}

/******************************
   Υǡ
 ******************************/
GList *combo_list_delete(GList *list)
{
  GList *tmp;
  char *tmp_buf;

  while (list) {
    tmp = list;
    list = g_list_remove_link (list, tmp);
    tmp_buf = (char *)(tmp->data);
    g_list_free_1 (tmp);
    /* debug */
    /*printf("%p:%s\n",tmp_buf, tmp_buf);*/
    g_free (tmp_buf);
  }
  return list;
}
