/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * Ƽ殺Хѿؿ
 */

/*
 * Cmemo : Text Editor
 * initial.c - source file for initialization
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "files.h"
#include "linenum.h"
#include "search.h"
#include "ini_file.h"
#include "kanji_conv.h"
#include "initial.h"
#include "keys.h"

/* local declarations */
static void init_ftype_info(void);
static void init_kmode_info(void);

/************************************************
   ftype_info¤ΤΥǡ(ǥե)
 ************************************************/
static void init_ftype_info(void)
{
  memset(cm_ft_inf, 0, sizeof(cm_ft_inf));

  /************************************************************
   ƥȥեʤ̾Υץ졼ƥȤФ
   ޤΥե뤫ȽǤʤäˤ⤳꤬Ȥ
   ************************************************************/
  cm_ft_inf[0].data_flag = 1;
  cm_ft_inf[0].enabled = 1;
  strcpy(cm_ft_inf[0].title, "Plain");
  strcpy(cm_ft_inf[0].mode, "text-mode");
  strcpy(cm_ft_inf[0].ext, ".txt;.ini;.inf;.back");
  cm_ft_inf[0].acckey = 'T';
  strcpy(cm_ft_inf[0].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[0].ignore_case = 0;
  strcpy(cm_ft_inf[0].key1buf, "http;ftp;mail");
  strcpy(cm_ft_inf[0].key2buf, "tel;no;room");
  strcpy(cm_ft_inf[0].cmt_start, "/*");
  strcpy(cm_ft_inf[0].cmt_end, "*/");
  strcpy(cm_ft_inf[0].line_cmt, "#");
  cm_ft_inf[0].str_start = '\"';
  cm_ft_inf[0].str_end = '\"';
  cm_ft_inf[0].chr_start = '\'';
  cm_ft_inf[0].chr_end = '\'';
  cm_ft_inf[0].esc_chr = '\\';
  cm_ft_inf[0].base_color = cm_base_color;
  cm_ft_inf[0].key1_color = cm_key1_color;
  cm_ft_inf[0].key2_color = cm_key2_color;
  cm_ft_inf[0].num_color = cm_number_color;
  cm_ft_inf[0].cmt_color = cm_comment_color;
  cm_ft_inf[0].str_color = cm_string_color;

  /***********
   Cץ
   ***********/
  /* ֹΥǡͭǤ뤫ɤɽե饰 */
  /* ץκǽ餫롼פʤ餳Υե饰 */
  /* å0ǤLang˥塼˲äʤ    */
  /* եˤϹԤʤΤǥ桼ռ */
  /* ɬפ̵͡                                       */
  cm_ft_inf[1].data_flag = 1;

  /* ˥塼ͭˤ뤫ɤΥե饰 */
  cm_ft_inf[1].enabled = 1;

  /* ˥塼ɽʸ */
  strcpy(cm_ft_inf[1].title, "C");

  /* ߥ˥Хåեɽ⡼ɤ̾ */
  strcpy(cm_ft_inf[1].mode, "c-mode");

  /* Υ⡼ɤΥ롼פ˴ޤޤեγĥ     */
  /* ʣꤹ϶򳫤˥ߥǶڤ */
  /*  ".txt;.ini;.inf;.log"                           */
  strcpy(cm_ft_inf[1].ext, ".c");

  /* Shift+Alt+(key)ǳƤ륢졼  */
  cm_ft_inf[1].acckey = 'C';

  /* ȡ˶ڤݤʸν */
  strcpy(cm_ft_inf[1].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");

  /* ɤʸʸ̤뤫ɤΥե饰 */
  cm_ft_inf[1].ignore_case = 0;

  /* ɣǤ2048Х̤ǻꤹ   */
  /* ʣꤹ϶򳫤˥ߥǶڤ */
  strcpy(cm_ft_inf[1].key1buf,
         "if;else;switch;case;default;break;for;while;do;continue;goto;"
         "sizeof;char;double;int;long;enum;float;short;unsigned;signed;void");

  /* ɣǤ2048Х̤ǻꤹ   */
  /* ʣꤹ϶򳫤˥ߥǶڤ */
  strcpy(cm_ft_inf[1].key2buf,
         "#include;#define;#if;#ifdef;#endif;#else;#ifndef;#undef;typedef;"
         "auto;register;extern;static;volatile;union;struct;const;return");

  /* ȳʸ */
  strcpy(cm_ft_inf[1].cmt_start, "/*");

  /* Ƚλʸ */
  strcpy(cm_ft_inf[1].cmt_end, "*/");

  /* ԥʸ */
  strcpy(cm_ft_inf[1].line_cmt, "");

  /* ʸ󳫻ʸ */
  /* ʸǤϤʤʸǻꤹ뤳Ȥ */
  cm_ft_inf[1].str_start = '\"';

  /* ʸλʸ */
  /* ʸǤϤʤʸǻꤹ뤳Ȥ */
  cm_ft_inf[1].str_end = '\"';

  /* ʸʸ */
  /* ʸǤϤʤʸǻꤹ뤳Ȥ */
  cm_ft_inf[1].chr_start = '\'';

  /* ʸλʸ */
  /* ʸǤϤʤʸǻꤹ뤳Ȥ */
  cm_ft_inf[1].chr_end = '\'';

  /* ʸ˻Ѥʸ */
  cm_ft_inf[1].esc_chr = '\\';

  cm_ft_inf[1].base_color = cm_base_color;
  cm_ft_inf[1].key1_color = cm_key1_color;
  cm_ft_inf[1].key2_color = cm_key2_color;
  cm_ft_inf[1].num_color = cm_number_color;
  cm_ft_inf[1].cmt_color = cm_comment_color;
  cm_ft_inf[1].str_color = cm_string_color;

  /*************
   C++ץ
   *************/
  cm_ft_inf[2].data_flag = 1;
  cm_ft_inf[2].enabled = 1;
  strcpy(cm_ft_inf[2].title, "C++");
  strcpy(cm_ft_inf[2].mode, "cpp-mode");
  strcpy(cm_ft_inf[2].ext, ".cpp;.cxx;.C;.cc;.h");
  cm_ft_inf[2].acckey = 'O';
  strcpy(cm_ft_inf[2].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[2].ignore_case = 0;
  strcpy(cm_ft_inf[2].key1buf,
         "if;else;switch;case;default;break;for;while;do;continue;goto;"
         "sizeof;char;double;int;long;enum;float;short;unsigned;signed;void");
  strcpy(cm_ft_inf[2].key2buf,
         "#include;#define;#ifdef;#endif;#else;#ifndef;#undef;typedef;auto;"
         "register;extern;static;volatile;union;struct;const;class;private;"
         "public;return");
  strcpy(cm_ft_inf[2].cmt_start, "/*");
  strcpy(cm_ft_inf[2].cmt_end, "*/");
  strcpy(cm_ft_inf[2].line_cmt, "//");
  cm_ft_inf[2].str_start = '\"';
  cm_ft_inf[2].str_end = '\"';
  cm_ft_inf[2].chr_start = '\'';
  cm_ft_inf[2].chr_end = '\'';
  cm_ft_inf[2].esc_chr = '\\';
  cm_ft_inf[2].base_color = cm_base_color;
  cm_ft_inf[2].key1_color = cm_key1_color;
  cm_ft_inf[2].key2_color = cm_key2_color;
  cm_ft_inf[2].num_color = cm_number_color;
  cm_ft_inf[2].cmt_color = cm_comment_color;
  cm_ft_inf[2].str_color = cm_string_color;

  /**************************
   Htmlɥ
   ɤʬʤΤŬǤ
   **************************/
  cm_ft_inf[3].data_flag = 1;
  cm_ft_inf[3].enabled = 1;
  strcpy(cm_ft_inf[3].title, "Html");
  strcpy(cm_ft_inf[3].mode, "html-mode");
  strcpy(cm_ft_inf[3].ext, ".html;.htm");
  cm_ft_inf[3].acckey = 'H';
  strcpy(cm_ft_inf[3].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[3].ignore_case = 1;

  /* Thanks to MATSUMURA Tomohiro for Html keywords */
  strcpy(cm_ft_inf[3].key1buf,
         "HTML;HEAD;TITLE;P;BR;UL;DL;TD;TR;HR;A;H;PRE");
  strcpy(cm_ft_inf[3].key2buf,
         "BODY;LINK;IMG;SRC;ALT;WIDTH;HEIGHT;HREF;LI;DT;DD;BORDER;ID;NAME");

  strcpy(cm_ft_inf[3].cmt_start, "<!--");
  strcpy(cm_ft_inf[3].cmt_end, "-->");
  strcpy(cm_ft_inf[3].line_cmt, "");
  cm_ft_inf[3].str_start = '\"';
  cm_ft_inf[3].str_end = '\"';
  cm_ft_inf[3].chr_start = '\0';
  cm_ft_inf[3].chr_end = '\0';
  cm_ft_inf[3].esc_chr = '\\';
  cm_ft_inf[3].base_color = cm_base_color;
  cm_ft_inf[3].key1_color = cm_key1_color;
  cm_ft_inf[3].key2_color = cm_key2_color;
  cm_ft_inf[3].num_color = cm_number_color;
  cm_ft_inf[3].cmt_color = cm_comment_color;
  cm_ft_inf[3].str_color = cm_string_color;

  /**************
   Javaץ
   **************/
  cm_ft_inf[4].data_flag = 1;
  cm_ft_inf[4].enabled = 1;
  strcpy(cm_ft_inf[4].title, "Java");
  strcpy(cm_ft_inf[4].mode, "java-mode");
  strcpy(cm_ft_inf[4].ext, ".java");
  cm_ft_inf[4].acckey = 'J';
  strcpy(cm_ft_inf[4].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[4].ignore_case = 0;
  strcpy(cm_ft_inf[4].key1buf,
         "boolean;break;byte;case;catch;char;continue;default;do;double;"
         "else;finally;float;for;goto;if;int;long;new;short;switch;this;"
         "throw;throws;try;void;while");
  strcpy(cm_ft_inf[4].key2buf,
         "abstract;class;const;extends;final;implements;import;instanceof;"
         "interface;native;package;private;protected;public;return;static;"
         "strictfp;super;synchronized;transient;volatile;widefp;true;false;"
         "null");
  strcpy(cm_ft_inf[4].cmt_start, "/*");
  strcpy(cm_ft_inf[4].cmt_end, "*/");
  strcpy(cm_ft_inf[4].line_cmt, "//");
  cm_ft_inf[4].str_start = '\"';
  cm_ft_inf[4].str_end = '\"';
  cm_ft_inf[4].chr_start = '\'';
  cm_ft_inf[4].chr_end = '\'';
  cm_ft_inf[4].esc_chr = '\\';
  cm_ft_inf[4].base_color = cm_base_color;
  cm_ft_inf[4].key1_color = cm_key1_color;
  cm_ft_inf[4].key2_color = cm_key2_color;
  cm_ft_inf[4].num_color = cm_number_color;
  cm_ft_inf[4].cmt_color = cm_comment_color;
  cm_ft_inf[4].str_color = cm_string_color;

  /****************
   Pascalץ
   ****************/
  cm_ft_inf[5].data_flag = 1;
  cm_ft_inf[5].enabled = 1;
  strcpy(cm_ft_inf[5].title, "Pascal");
  strcpy(cm_ft_inf[5].mode, "pascal-mode");
  strcpy(cm_ft_inf[5].ext, ".pas;.dpr;.dpk;.inc");
  cm_ft_inf[5].acckey = 'P';
  strcpy(cm_ft_inf[5].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[5].ignore_case = 1;
  strcpy(cm_ft_inf[5].key1buf,
         "and;as;case;div;do;downto;else;for;goto;if;in;is;mod;not;of;"
         "or;out;packed;then;to;while;try;finally;except;finalization;"
         "with;xor;until;file;nil;string;object;label;library;"
         "resourcestring;integer;read;write;char;begin;end;interface;"
         "implementation;threadvar;var");
  strcpy(cm_ft_inf[5].key2buf,
         "class;const;dynamic;dispid;safecall;stdcall;overload;override;"
         "stored;property;program;initialization;inherited;inline;function;"
         "dispinterface;constructor;destructor;private;public;protected;"
         "published;virtual;automated;procedure;unit;far;forward;implements;"
         "exports;export;external;type;uses;absolute;abstract;assembler;at;"
         "automated;cdecl;contains;default;index;message;name;near;shl;shr;"
         "nodefaul;package;pascal;readonly;writeonly;repeat;raise;register;"
         "requires;resident;reintroduce;record;set;array;asm");
  strcpy(cm_ft_inf[5].cmt_start, "{");
  strcpy(cm_ft_inf[5].cmt_end, "}");
  strcpy(cm_ft_inf[5].line_cmt, "//");
  cm_ft_inf[5].str_start = '\'';
  cm_ft_inf[5].str_end = '\'';
  cm_ft_inf[5].chr_start = '\'';
  cm_ft_inf[5].chr_end = '\'';
  cm_ft_inf[5].esc_chr = '#';
  cm_ft_inf[5].base_color = cm_base_color;
  cm_ft_inf[5].key1_color = cm_key1_color;
  cm_ft_inf[5].key2_color = cm_key2_color;
  cm_ft_inf[5].num_color = cm_number_color;
  cm_ft_inf[5].cmt_color = cm_comment_color;
  cm_ft_inf[5].str_color = cm_string_color;

  /********************************
   Tcl/Tkץ
   TkޥɤϤޤäƤޤ
   ********************************/
  cm_ft_inf[6].data_flag = 1;
  cm_ft_inf[6].enabled = 1;
  strcpy(cm_ft_inf[6].title, "Tcl/Tk");
  strcpy(cm_ft_inf[6].mode, "tcltk-mode");
  strcpy(cm_ft_inf[6].ext, ".tcl;.tk;.TCL;.TK");
  cm_ft_inf[6].acckey = 'L';
  strcpy(cm_ft_inf[6].delimiter, " \n\t\\\'\";:,.*+-/%[]{}()<>&!?=");
  cm_ft_inf[6].ignore_case = 0;
  strcpy(cm_ft_inf[6].key1buf,
         "set;unset;incr;append;expr;array;exists;size;get;names;startsearch;"
         "nextelement;donesearch;split;join;string;compare;index;range;first;"
         "last;wordstart;wordend;match;tolower;toupper;trimleft;trimright;trim;"
         "format;scan;regexp;regsub;llength;lindex;concat;list;lappend;linsert;"
         "lrange;lreplace;lsearch;open;close;gets;read;puts;flush;tell;seek;"
         "fblocked;fconfigure;socket;file;atime;mtime;exists;executable;owned;"
         "readable;writable;isfile;isdirectory;type;readlink;dirname;tail;"
         "extension;stat;lstat;glob;pwd;cd;if;for;foreach;while;break;continue;"
         "switch;catch;exec;edit;search;help;toplevel");
  strcpy(cm_ft_inf[6].key2buf,
         "proc;return;code;errorinfo;errorcode;global;upvar;uplevel;exit;rename;"
         "pid;time;clock;clicks;seconds;format;scan;info;args;body;cmdcount;"
         "commands;eval;subst;source;interp;create;delete;exists;issafe;slaves;"
         "eval;alias;target;aliases;share;transfer;auto_execok;auto_load;"
         "auto_mkindex;auto_reset;parray;package;require;ifneeded;unknown;"
         "provide;forget;names;versions;vcompare;vsatisfies;load;pkg_mkIndex;"
         "wish");
  strcpy(cm_ft_inf[6].cmt_start, "\0");
  strcpy(cm_ft_inf[6].cmt_end, "\0");
  strcpy(cm_ft_inf[6].line_cmt, "#");
  cm_ft_inf[6].str_start = '\"';
  cm_ft_inf[6].str_end = '\"';
  cm_ft_inf[6].chr_start = '\0';
  cm_ft_inf[6].chr_end = '\0';
  cm_ft_inf[6].esc_chr = '\\';
  cm_ft_inf[6].base_color = cm_base_color;
  cm_ft_inf[6].key1_color = cm_key1_color;
  cm_ft_inf[6].key2_color = cm_key2_color;
  cm_ft_inf[6].num_color = cm_number_color;
  cm_ft_inf[6].cmt_color = cm_comment_color;
  cm_ft_inf[6].str_color = cm_string_color;

  return;
}

/********************************
   kmode_info¤ΤΥǡ
 ********************************/
static void init_kmode_info(void)
{
  int i;

  i = 0;
  memset(cm_km_inf, 0, sizeof(cm_km_inf));

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = ASCII; /* 5 */
  strcpy(cm_km_inf[i].title, "ASCII");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = EUC_JP; /* 0 */
  strcpy(cm_km_inf[i].title, "EUC_JP");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = SHIFT_JIS; /* 1 */
  strcpy(cm_km_inf[i].title, "SHIFT_JIS");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = JIS2022; /* 2 */
  strcpy(cm_km_inf[i].title, "JIS2022");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 1;
  cm_km_inf[i].mode_id = UTF_8; /* 3 */
  strcpy(cm_km_inf[i].title, "UTF_8");
  i++;

  cm_km_inf[i].data_flag = 1;
  cm_km_inf[i].enabled = 0;
  cm_km_inf[i].mode_id = BINARY; /* 4 */
  strcpy(cm_km_inf[i].title, "BINARY(\?\?\?)");
  i++;

  return;
}

/********************************
   Ƽե饰ؿ
 ********************************/
int init_flags(void)
{
  cm_end_flag = 0;
  cm_all_lines = 1;
  cm_input_mode = 0;
  /*cm_kanji_mode = EUC_JP;*/
  cm_kanji_mode = ASCII;
  cm_return_mode = CME_LF;

  /* ưǥȤͭˤ뤫ɤɽ(0:̵ 1:ͭ) */
  cm_indent_mode = 0;

  /* κݤʸʸ̵뤹뤫ɤɽ(0: 1:̵) */
  cm_ignore_case = 0;

  /* ١顼(֥å) */
  cm_base_color.red = 0x0000;
  cm_base_color.green = 0x0000;
  cm_base_color.blue = 0x0000;

  /* ɥ顼(꡼) */
  cm_key1_color.red = 0x0000;
  cm_key1_color.green = 0x8888;
  cm_key1_color.blue = 0x0000;

  /* ɥ顼(֥롼) */
  cm_key2_color.red = 0x0000;
  cm_key2_color.green = 0x0000;
  cm_key2_color.blue = 0xffff;

  /* ͥ顼(å) */
  cm_number_color.red = 0xffff;
  cm_number_color.green = 0x0000;
  cm_number_color.blue = 0x0000;

  /* ȥ顼(С) */
  cm_comment_color.red = 0x8888;
  cm_comment_color.green = 0x6666;
  cm_comment_color.blue = 0x5555;

  /* ʸ󥫥顼(С) */
  cm_string_color.red = 0x7777;
  cm_string_color.green = 0x7777;
  cm_string_color.blue = 0x7777;

  init_ftype_info();
  init_kmode_info();
  init_key_macro_events();

  return(0);
}
