/*
 * GTK+(2.0.x)ѤPC-UNIXѥĢΥ
 *
 * ܸʸɤߤѴؿ
 * ʸɤưŪȽ̤ؿ              
 */

/*
 * Cmemo : Text Editor
 * kanji_conv.c - kanji convert source file
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/*debug*/
/*#include <stdio.h>*/
#include <string.h>
#include "kanji_conv.h"
#include "sjis2euc.h"

#define OFF 0
#define ON  1

int find_sjis2euc(int s1, int s2)
{
  int i, sjis_val;
  sjis_val = s1 * 0x100 + s2;
  for (i = 0; i < sjis_to_euc_table_size; i++) {
    if (sjis_to_euc_table[i].sjis == sjis_val)
      return(sjis_to_euc_table[i].euc);
  }
  return(-1);
}

/*pdestˤϽʬΰݤƤʤФʤʤȤ*/
/*Shift-JisEUCѴ硢ȾѲ̾ʸܤΰ褬ɬ*/
int sjis_to_euc(unsigned char *pdest, unsigned char *psrc)
{
  unsigned char *src_pos;
  unsigned char *dest_pos;

  src_pos = psrc;
  dest_pos = pdest;

  while ((int)*src_pos != (int)'\0') {
    /*Shift-Jisդ*/
    if (((int)*src_pos >= 0x81) && (((int)*src_pos <= 0x9f) ||
        (((int)*src_pos >= 0xe0) && ((int)*src_pos <= 0xfc)))) {
      int i_euc = find_sjis2euc((int)*src_pos, (int)(*(src_pos + 1)));
      if (i_euc > 0) {
        unsigned short euc_val = i_euc;
        *dest_pos = (euc_val >> 8) & 0xff;
        src_pos++;
        dest_pos++;
        if ((int)*src_pos == (int)'\0') {
          break;
        }
        *dest_pos = euc_val & 0xff;
        src_pos++;
        dest_pos++;
        continue;
      }
      else if ((int)*src_pos >= 0xe0) {
        *dest_pos = (*src_pos - 0xc1) << 1;
      }
      else {
        *dest_pos = (*src_pos - 0x81) << 1;
      }

      if ((int)(*(src_pos + 1)) >= 0x9f) {
        *dest_pos = (*dest_pos + 0x22) | 0x80;
        src_pos++;
        dest_pos++;
        *dest_pos = (*src_pos - 0x7e) | 0x80;
        src_pos++;
        dest_pos++;
      }
      else if (((int)(*(src_pos + 1)) >= 0x7f) && ((int)(*(src_pos + 1)) < 0x9f)) {
        *dest_pos = (*dest_pos + 0x21) | 0x80;
        src_pos++;
        dest_pos++;
        *dest_pos = (*src_pos - 0x20) | 0x80;
        src_pos++;
        dest_pos++;
      }
      else {
        *dest_pos = (*dest_pos + 0x21) | 0x80;
        src_pos++;
        dest_pos++;
        *dest_pos = (*src_pos - 0x1f) | 0x80;
        src_pos++;
        dest_pos++;
      }
    }
    /*ȾѲ̾դ*/
    else if ((int)*src_pos >= 0xa1 && (int)*src_pos <= 0xdf) {
      /*Хܤ0x8e򥻥å*/
      *dest_pos = 0x8e;
      dest_pos++;
      /*Хܤˤϸդɤ򤽤Τޤޥå*/
      *dest_pos = *src_pos;
      src_pos++;
      dest_pos++;
    }
    /*嵭ʳasciiʸ*/
    else {
      *dest_pos = *src_pos;
      src_pos++;
      dest_pos++;
    }
  }

  return(0);
}

/*JisEUCѴϸΰۤ뤳Ȥ̵*/
int jis_to_euc(unsigned char *pdest, unsigned char *psrc)
{
  int jis_on = OFF;
  unsigned char *src_pos;
  unsigned char *dest_pos;

  src_pos = psrc;
  dest_pos = pdest;

  while ((int)*src_pos != (int)'\0') {
    /*ץɤդä*/
    if ((int)*src_pos == 0x1b) {
      /*JisΣХʸλϤޤ*/
      if (((int)(*(src_pos + 1)) == '$') &&
              (((int)(*(src_pos + 2)) == 'B') || ((int)(*(src_pos + 2)) == '@'))) {
        jis_on = ON;
        src_pos++;
        src_pos++;
        src_pos++;
      }
      /*JisΣХʸν*/
      else if (((int)(*(src_pos + 1)) == '(') &&
         (((int)(*(src_pos + 2)) == 'B') || ((int)(*(src_pos + 2)) == 'J'))) {
        jis_on = OFF;
        src_pos++;
        src_pos++;
        src_pos++;
      }
    }

    if (jis_on == OFF) {
      *dest_pos = *src_pos;
      src_pos++;
      dest_pos++;
    }
    else {
      *dest_pos = *src_pos | 0x80;
      src_pos++;
      dest_pos++;
      *dest_pos = *src_pos | 0x80;
      src_pos++;
      dest_pos++;
    }
  }    

  return(0);
}

/*EUCShift-JisѴϸΰۤ뤳Ȥ̵*/
int euc_to_sjis(unsigned char *pdest, unsigned char *psrc)
{
  unsigned char *src_pos;
  unsigned char *dest_pos;

  src_pos = psrc;
  dest_pos = pdest;

  while ((int)*src_pos != (int)'\0') {
    /*EUCɤդä*/
    if ((int)*src_pos > 0x7F) {
      /*ХʸΣХܤդä碣ɽ*/
      if ((int)*src_pos == 0x8f) {
        *dest_pos = 0x81;
        *(dest_pos + 1) = 0xa1;
        src_pos++;
        src_pos++;
        src_pos++;
        dest_pos++;
        dest_pos++;
      }
      /*ȾѲ̾ʸդä*/
      else if ((int)*src_pos == 0x8e) {
        src_pos++;
        *dest_pos = *src_pos;
        src_pos++;
        dest_pos++;
      }
      /*嵭ʳϣХʸ*/
      else {
        if ((((int)*src_pos >= 0xa1) && ((int)*src_pos <= 0xfe)) &&
            (((int)(*(src_pos + 1)) >= 0xa1) && ((int)(*(src_pos + 1)) <= 0xfe))) {
          /*ХܤJisɤѴʤShift-JisѴ*/
          if (((int)*src_pos & 0x7f) <= 0x5e) {
            *dest_pos = (((*src_pos & 0x7f) - 0x21) >> 1) + 0x81;
          }
          else {
            *dest_pos = (((*src_pos & 0x7f) - 0x21) >> 1) + 0xc1;
          }
          /*ХܤJisɤѴʤShift-JisѴ*/
          if ((int)(*src_pos & 0x01) == 0) {
            *(dest_pos + 1) = ((*(src_pos + 1)) & 0x7f) + 0x7e;
          }
          else {
            if ((int)((*(src_pos + 1)) & 0x7f) <= 0x5f) {
              *(dest_pos + 1) = ((*(src_pos + 1)) & 0x7f) + 0x1f;
            }
            else {
              *(dest_pos + 1) = ((*(src_pos + 1)) & 0x7f) + 0x20;
            }
          }
        }
        /*EUCʸǤϤʤasciiʸǤʤΥɤϢѴ*/
        else {
          *dest_pos = 0x81;
          *(dest_pos + 1) = 0xa1;
        }
        /*ݥ󥿤ʤ*/
        src_pos++;
        src_pos++;
        dest_pos++;
        dest_pos++;
      }
    }
    /*asciiʸξ*/
    else {
      *dest_pos = *src_pos;
      src_pos++;
      dest_pos++;
    }
  }

  return(0);
}

unsigned int euc_to_jis_size(unsigned char *psrc)
{
  int jis_on = OFF;
  unsigned char *src_pos;
  unsigned int len;

  src_pos = psrc;
  len = strlen(psrc);

  while ((int)*src_pos != (int)'\0') {
    /*EUCɤξ*/
    if ((int)*src_pos > 0x7F) {
      /*asciiʸ飲ХʸؤڤؤǣХȻȤ*/
      if (jis_on == OFF) {
        len = len + 3;
        jis_on = ON;
      }
      /*ݥ󥿤ʤ*/
      if ((int)*src_pos != 0x8F) {
        src_pos++;
        src_pos++;
      }
      else {
        src_pos++;
        src_pos++;
        src_pos++;
      }
    }
    /*asciiʸξ*/
    else {
      /*ХʸasciiʸؤڤؤǣХȻȤ*/
      if (jis_on == ON) {
        len = len + 3;
        jis_on = OFF;
      }
      /*ݥ󥿤ʤ*/
      src_pos++;
    }
  }

  return(len);
}

/*EUCJisѴ硢ɤΰѰդɤΤ*/
/*ԳʤΤǡδؿ򥳡뤹euc_to_jis_size򥳡*/
/*ɬפΰĴ٤ʤФʤʤ*/
int euc_to_jis(unsigned char *pdest, unsigned char *psrc)
{
  int jis_on = OFF;
  unsigned char *src_pos;
  unsigned char *dest_pos;

  src_pos = psrc;
  dest_pos = pdest;

  while ((int)*src_pos != (int)'\0') {
    /*EUCɤդä*/
    if ((int)*src_pos > 0x7F) {
      /*asciiʸ飲ХʸؤڤؤǣХȻȤ*/
      if (jis_on == OFF) {
        *dest_pos = 0x1b;
        *(dest_pos + 1) = '$';
        *(dest_pos + 2) = 'B';
        dest_pos++;
        dest_pos++;
        dest_pos++;
        jis_on = ON;
      }
      /*ХʸΣХܤդä碣ɽ*/
      if ((int)*src_pos == 0x8f) {
        *dest_pos = 0x22;
        *(dest_pos + 1) = 0x23;
        src_pos++;
        src_pos++;
        src_pos++;
        dest_pos++;
        dest_pos++;
      }
      /*ȾѲ̾ʸդä碣ɽ*/
      else if ((int)*src_pos == 0x8e) {
        *dest_pos = 0x22;
        *(dest_pos + 1) = 0x23;
        src_pos++;
        src_pos++;
        dest_pos++;
        dest_pos++;
      }
      /*嵭ʳϣХʸ*/
      else {
        if ((((int)*src_pos >= 0xa1) && ((int)*src_pos <= 0xfe)) &&
            (((int)(*(src_pos + 1)) >= 0xa1) && ((int)(*(src_pos + 1)) <= 0xfe))) {
          /*ХܤȣХܤJisɤѴ*/
          *dest_pos = (*src_pos) & 0x7f;
          *(dest_pos + 1) = (*(src_pos + 1)) & 0x7f;
        }
        /*EUCʸǤϤʤasciiʸǤʤΥɤϢѴ*/
        else {
          *dest_pos = 0x22;
          *(dest_pos + 1) = 0x23;
        }
        /*ݥ󥿤ʤ*/
        src_pos++;
        src_pos++;
        dest_pos++;
        dest_pos++;
      }
    }
    /*asciiʸξ*/
    else {
      /*ХʸasciiʸؤڤؤǣХȻȤ*/
      if (jis_on == ON) {
        *dest_pos = 0x1b;
        *(dest_pos + 1) = '(';
        *(dest_pos + 2) = 'B';
        dest_pos++;
        dest_pos++;
        dest_pos++;
        jis_on = OFF;
      }
      *dest_pos = *src_pos;
      src_pos++;
      dest_pos++;
    }
  }

  return(0);
}

/****************************************************************
   ʸɤȽ̤ؿ(ޤʬȤϸʤ 2000/07/08)
   UTF-8Ƚɲ(פɤ԰¤ĤäƤ 2001/10/15)
 ****************************************************************/
int what_kanji_code(unsigned char *psrc)
{
  unsigned char *src_pos;
  int utf8_byte;
  int utf8;
  int sjis;
  int eucjp;
  int mb_flag;
  int result;

  src_pos = psrc;
  utf8_byte = 0;
  utf8 = 0;
  sjis = 0;
  eucjp = 0;
  mb_flag = 0;
  /* ǥեȤEUC_JP */
  result = EUC_JP;

  while ((int)*src_pos != (int)'\0') {
    /* JISǤ뤫ɤȽ */
    if ((int)*src_pos == 0x1b) {
      /* ASCII飲Хʸؤڤؤ */
      if (((int)(*(src_pos + 1)) == '(') &&
         (((int)(*(src_pos + 2)) == 'B') || ((int)(*(src_pos + 2)) == 'J'))) {
        return(JIS2022);
      }
      /* ХʸASCIIؤڤؤ */
      else if (((int)(*(src_pos + 1)) == '$') &&
              (((int)(*(src_pos + 2)) == 'B') || ((int)(*(src_pos + 2)) == '@'))) {
        return(JIS2022);
      }
    }
    /* ޥХʸ */
    if ((int)*src_pos >= 0x80) {
      /* UTF-8 Ƭ */
      if( ((int)*src_pos & 0xc0) == 0x80 ) {
        if( utf8_byte == 0 )
          utf8--;
        else {
          utf8_byte--;
        }
      }
      /* UTF-8 Ƭ */
      else {
        if( utf8_byte != 0 ){
          utf8--;
          utf8_byte=0;
        }
        if(((int)*src_pos & 0xc0) == 0xc0) {	
          utf8_byte++;
          if(((int)*src_pos & 0xe0) == 0xe0) {
            utf8_byte++;
            if(((int)*src_pos & 0xf0) == 0xf0) {
              utf8_byte++;
              if(((int)*src_pos & 0xf8) == 0xf8) {
                utf8_byte++;
                if(((int)*src_pos & 0xfc) == 0xfc) {
                  utf8_byte++;
                }
              }
            }
          } 
        }
      }

      if (mb_flag == 0) {
        /* EUCޤShift-JisȽ */
        if ((int)*src_pos <= 0xa0) {
          if ((int)*src_pos != 0x8e) {
            /* EUCȾѲ̾βǽʤShift-Jis */
            /*return(SHIFT_JIS);*/
            sjis++;
            /* UTF8Shift-Jisȸǧ뤫...    */
            /* EUCΣХʸǤäˤϸǧȤʤ */
            /* Shift-JisΣХʸ+Shift-JisȾѲ̾ */
            /* EUCΣХʸȤζ̤դʤǤ */
          }
        }
        else {
          if ((int)(*(src_pos + 1)) <= 0x7f) {
            /*return(SHIFT_JIS);*/
            sjis++;
          }
          else if ((int)(*(src_pos + 1)) >= 0xfd) {
            /*return(EUC_JP);*/
            eucjp++;
          }
        }
        mb_flag = 1;
      }
      else {
        mb_flag = 0;
      }

      /* ݥ󥿤ʤ */
      src_pos++;
      if ((int)*src_pos == (int)'\0') {
        /* Shift-JisȾѲ̾ĸ줿硢Хʸη׻ */
        /* ʤ롣äơShift-JisǤȽǤƴؿȴ */
        /*return(SHIFT_JIS);*/
        /* 1ХȤĿʤ褦ˤΤShift-JisǤȤϤʤ */
        /* sjis++; */
        break;
      }
    }
    else {
      /*ݥ󥿤ʤ*/
      src_pos++;
    }
  }

  if (sjis > 0) {
    result = SHIFT_JIS;
  }
  if (utf8 == 0) {
    result = UTF_8;
  }
  if ((sjis == 0) && (utf8 == 0) && (eucjp == 0)) {
    result = ASCII;
  }
  /* debug */
  /*printf("utf8  %d\n", utf8);*/
  /*printf("sjis  %d\n", sjis);*/
  /*printf("eucjp %d\n", eucjp);*/
  return(result);
}

/*δؿϥʸޤʤΤǤޤ̤*/
int sjis_to_jis(unsigned char *pdest, unsigned char *psrc)
{
  unsigned char *src_pos;
  unsigned char *dest_pos;

  src_pos = psrc;
  dest_pos = pdest;

  while ((int)*src_pos != (int)'\0') {
    if (((int)*src_pos >= 0x81) && (((int)*src_pos <= 0x9f) ||
        (((int)*src_pos >= 0xe0) && (int)*src_pos <= 0xfc))) {
      if ((int)*src_pos >= 0xe0) {
        *dest_pos = (*src_pos - 0xc1) << 1;
      }
      else {
        *dest_pos = (*src_pos - 0x81) << 1;
      }

      if ((int)(*(src_pos + 1)) >= 0x9f) {
        *dest_pos = *dest_pos + 0x22;
        src_pos++;
        dest_pos++;
        *dest_pos = *src_pos - 0x7e;
        src_pos++;
        dest_pos++;
      }
      else if (((int)(*(src_pos + 1)) >= 0x7f) && ((int)(*(src_pos + 1)) < 0x9f)) {
        *dest_pos = *dest_pos + 0x21;
        src_pos++;
        dest_pos++;
        *dest_pos = *src_pos - 0x20;
        src_pos++;
        dest_pos++;
      }
      else {
        *dest_pos = *dest_pos + 0x21;
        src_pos++;
        dest_pos++;
        *dest_pos = *src_pos - 0x1f;
        src_pos++;
        dest_pos++;
      }
    }
    else if ((int)*src_pos >= 0xa1 && (int)*src_pos <= 0xdf) {
      *dest_pos = 0x8e;
      dest_pos++;
      *dest_pos = *src_pos;
      src_pos++;
      dest_pos++;
    }
    else {
      *dest_pos = *src_pos;
      src_pos++;
      dest_pos++;
    }
  }

  return(0);
}

/**************************************
   ƤβԥɤLFѴؿ
 **************************************/
int all_to_lf(unsigned char *text)
{
  int ret_code; /*CME_LF  CME_CR  CME_CRLF Τ줫*/
  unsigned int len;
  unsigned int i;
  unsigned int j;


  ret_code = CME_LF;
  j = 0;

  len = strlen(text);
  for (i = 0; i < len; i++) {
    if ((int)(text[i]) == 0x0d) {
      if ((int)(text[i + 1]) == 0x0a) {
        i = i + 1;
        ret_code = CME_CRLF;
      }
      else {
        text[i] = 0x0a;
        if (ret_code != CME_CRLF) {
          ret_code = CME_CR;
        }
      }
    }
    text[j] = text[i];
    j = j + 1;
  }
  text[j] = '\0';

  return(ret_code);
}

void lf_to_cr(unsigned char *text)
{
  unsigned int len;
  unsigned int i;


  len = strlen(text);
  for (i = 0; i < len; i++) {
    if ((int)(text[i]) == 0x0a) {
      text[i] = 0x0d;
    }
  }

  return;
}

void lf_to_crlf(unsigned char *pdest, unsigned char *psrc)
{
  unsigned int len;
  unsigned int i;
  unsigned int j;


  j = 0;

  len = strlen(psrc);
  for (i = 0; i < len; i++) {
    if ((int)(psrc[i]) == 0x0a) {
      pdest[j] = 0x0d;
      j = j + 1;
    }
    pdest[j] = psrc[i];
    j = j + 1;
  }

  pdest[j] = '\0';

  return;
}
