/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * ߥåȤΤԤιֹؿ
 */

/*
 * Cmemo : Text Editor
 * linenum.c - source file for getting current line number
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "cme_misc.h"


int cm_line_count[MAX_LINE_COUNT + 2]; /*ʸƬΥݥ*/
unsigned int cm_all_lines; /*ƥȤԿ*/

static int line = 1; /* ߲ܤǤ뤫ɽѿ */
static int kakko1_count = 0; /* { } οͭ*/
static int kakko2_count = 0; /* ( ) οͭ*/
static int ncount[MAX_LINE_COUNT]; /*ɲä줿ʸβʸΰ*/


/****************************************
   ߥåȤΤԤιֹ֤
 ****************************************/
int get_cur_line_number(void)
{
  return line;
}

/****************************************
   ߥåȤΤԤιֹ
 ****************************************/
void set_cur_line_number(int line_num)
{
  line = line_num;
  return;
}

/****************************************
   ̤б֤ɽѿ
 ****************************************/
void init_kakko_count(void)
{
  kakko1_count = 0; /* { } οͭ*/
  kakko2_count = 0; /* ( ) οͭ*/
  return;
}

void line_count_insert(GtkEditable *editable, const char *text,
                       int len, int *pos, gpointer d)
{
  int i;
  int j;    /*ɲä줿ʸβʸθĿ*/
  unsigned char *buf;
  char *buf_start;
  int chr_num;    /*ʸ(buf ΥХȿǤϤʤ)*/


  buf = g_new0 (char, len + 1);
  strncpy (buf, text, len);
  buf_start = buf;

  kakko_add_cb(buf_start);

  i = 0;
  j = 0;

  /*ʸ򥫥Ȥ*/
  chr_num = get_char_count(buf, strlen(buf), &j, ncount);

  free(buf_start);

  /*Կ򹹿*/
  cm_all_lines = cm_all_lines + j;
  /* debug */
  /*g_print("line_count_insert cm_all_lines : %d\n", cm_all_lines);*/

  for (i = 0; i < MAX_LINE_COUNT - 1; i++) {
    if ((*pos > cm_line_count[i]) && (*pos <= cm_line_count[i + 1])) {
      line = i + 1;
      break;
    }
  }

  if (line > MAX_LINE_COUNT - 1) {
    line = MAX_LINE_COUNT;
  }

  if (*pos == 0) {
    line = 1;
  }

  if (j != 0) {
    for (i = MAX_LINE_COUNT - 1; i > line - 1; i--) {
      if ((i + j) < MAX_LINE_COUNT) {
        cm_line_count[i + j] = cm_line_count[i] + chr_num;
      }
    }
    for (i = 0; i < j; i++) {
      if ((line + i) < MAX_LINE_COUNT) {
        cm_line_count[line + i] = *pos + ncount[i];
      }
    }
  }
  else {
    for (i = MAX_LINE_COUNT - 1; i > line - 1; i--) {
      cm_line_count[i] = cm_line_count[i] + chr_num;
    }
  }
  /*g_print("ins\n");*/
  return; 
}

void line_count_delete(GtkEditable *editable, int start, int end, gpointer d)
{
  int i;
  int j;    /*줿ʸβʸθĿ*/
  char *text;
  unsigned char *buf;
  /*int len;*/
  int chr_num;    /*ʸ(buf ΥХȿǤϤʤ)*/


  /*len = end - start;*/
  text = gtk_editable_get_chars (editable, start, end);
  buf = text;

  kakko_del_cb(text);

  i = 0;
  j = 0;

  /*ʸ򥫥Ȥ*/
  chr_num = get_char_count(buf, strlen(buf), &j, NULL);

  free(text);

  /*Կ򹹿*/
  cm_all_lines = cm_all_lines - j;
  /* debug */
  /*g_print("line_count_delete cm_all_lines : %d\n", cm_all_lines);*/

  for (i = 0; i < MAX_LINE_COUNT - 1; i++) {
    if ((start > cm_line_count[i]) && (start <= cm_line_count[i + 1])) {
      line = i + 1;
      break;
    }
  }

  if (line > MAX_LINE_COUNT - 1) {
    line = MAX_LINE_COUNT;
  }

  if (start == 0) {
    line = 1;
  }

  if ((j != 0) && (line < MAX_LINE_COUNT - 1)) {
    for (i = line; i < MAX_LINE_COUNT - 1; i++) {
      if ((i + j) < MAX_LINE_COUNT) {
        cm_line_count[i] = cm_line_count[i + j] - chr_num;
      }
    }
  }
  else {
    for (i = line; i < MAX_LINE_COUNT - 1; i++) {
      cm_line_count[i] = cm_line_count[i] - chr_num;
    }
  }
  /*g_print("del\n");*/
  return; 
}

void kakko_add_cb(char *buf)
{
  char *pos;

  pos = buf;

  while ((int)*pos != (int)'\0') {
    if ((int)*pos == (int)'{') {
      kakko1_count++;
    }
    else if ((int)*pos == (int)'}') {
      kakko1_count--;
    }
    else if ((int)*pos == (int)'(') {
      kakko2_count++;
    }
    else if ((int)*pos == (int)')') {
      kakko2_count--;
    }
    pos++;
  }
  /*g_print("{%d} (%d)\n", kakko1_count, kakko2_count);*/
  return;
}

void kakko_del_cb(char *buf)
{
  char *pos;

  pos = buf;

  while ((int)*pos != (int)'\0') {
    if ((int)*pos == (int)'{') {
      kakko1_count--;
    }
    else if ((int)*pos == (int)'}') {
      kakko1_count++;
    }
    else if ((int)*pos == (int)'(') {
      kakko2_count--;
    }
    else if ((int)*pos == (int)')') {
      kakko2_count++;
    }
    pos++;
  }
  /*g_print("{%d} (%d)\n", kakko1_count, kakko2_count);*/
  return;
}

/******************************************
   ֹ湹ΰ٤Υǡؿ
 ******************************************/
/* char_countgtk_text_get_lengthͤϤ */
void line_number_init_cb(unsigned char *textbuf, gint char_count)
{
  unsigned char *tmp;
  gint i;
  gint count;
  unsigned int j;
  unsigned int len;

  tmp = textbuf;
  i = 1;
  count = 0;
  cm_line_count[0] = 0;

  /*ʸ򥫥Ȥ*/
  count = get_char_count(tmp, strlen(tmp), &i, &cm_line_count[1]);
  i = i + 1;
  cm_line_count[i] = char_count;

  /*MAX_LINE_COUNTͤˤ餺Կ򥻥å*/
  len = strlen(textbuf);
  cm_all_lines = 1;
  for (j = 0; j < len; j++) {
    if ((int)textbuf[j] == 0x0a) {
      cm_all_lines = cm_all_lines + 1;
    }
  }
  return;
}


/****************************************
   åȰ֤ιֹ򹹿ؿ
 ****************************************/
void line_number_cb(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  gint pos;
  gint i;
  gint count;
  gchar buffer[256]; /* Է(L%d-C%d)碌256ХȤ⤢פ */
  gchar *buf;
  gchar kakko1_buffer[16];
  gchar *kakko1_buf;
  gchar kakko2_buffer[16];
  gchar *kakko2_buf;
  GdkEventKey *kevent = (GdkEventKey *)event;
  gchar entry_text[512];
  gint column;


  /* 硼ȥåȥǽλ褦Ȥȥ顼å */
  /* ФΤǡ򤹤ե饰å         */
  if (cm_end_flag == 1) {
    return;
  }

  if (kevent->keyval == GDK_Control_L || kevent->keyval == GDK_Control_R
      || kevent->keyval == GDK_Shift_L || kevent->keyval == GDK_Shift_R) {
    /*printf("control\n");*/
    return;
  }

  pos = gtk_editable_get_position(GTK_EDITABLE(current_document->textbox));

  for (i = 0; i < MAX_LINE_COUNT - 1; i++) {
    if ((pos > cm_line_count[i]) && (pos <= cm_line_count[i + 1])) {
      line = i + 1;
      break;
    }
  }

  if (line > MAX_LINE_COUNT - 1) {
    line = MAX_LINE_COUNT;
  }

  if (pos == 0) {
    line = 1;
  }

  count = line;
  if (count == 1) {
    column = pos - cm_line_count[count - 1];
  }
  else {
    column = pos - cm_line_count[count - 1] - 1;
  }

  buf = buffer;
  sprintf(buf, "L%d-C%d", count, column);

  kakko1_buf = kakko1_buffer;
  sprintf(kakko1_buf, "{%d}", kakko1_count);

  kakko2_buf = kakko2_buffer;
  sprintf(kakko2_buf, "(%d)", kakko2_count);

  sprintf(&entry_text[0], MODE_LINE_DEFAULT_MSG, kakko1_buf, kakko2_buf, buf);
  mlwrite(&entry_text[0], DELAY_UPDATING);

  return;
}
