/*
 * GTK+(1.2.x)ѤPC-UNIXѥĢΥ
 *
 * Ӳΰ٤δؿ
 */

/*
 * Cmemo : Text Editor
 * search.c - source file for searching strings
 *
 * Copyright (C) 2000, 2001, 2002 Seiji Tamura
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "cme_def.h"
#include "cmemo.h"
#include "linenum.h"
#include "document.h"
#include "cme_misc.h"
#include "bm_search.h"


#define SEARCH_UP 0
#define SEARCH_DN 1

int cm_ignore_case;


/************
   岼
 ************/
/* 0:FALSE 1:TRUE  */
int search_up_dn(unsigned char *s_text, unsigned char *s_word,
                 long *count_from_start, long *num_of_char,
                 int up_dn_flag, int matchcase)
{
  int hit_pos;
  unsigned char *search_p;


  if (up_dn_flag == SEARCH_UP) {
    hit_pos = bm_re_search(s_text, strlen(s_text), s_word, strlen(s_word), matchcase);
  }
  else { /* SEARCH_DN */
    hit_pos = bm_search(s_text, strlen(s_text), s_word, strlen(s_word), matchcase);
  }
  if (hit_pos == -1) {
    search_p = NULL;
  }
  else {
    search_p = s_text + hit_pos;
  }

  if (search_p == NULL) {
    return(0);
  }
  else {
    /*ȯ֤ޤǤʸ򥫥Ȥ*/
    *count_from_start = get_char_count(s_text, search_p - s_text, NULL, NULL);

    /*ñʸ򥫥Ȥ*/
    *num_of_char = get_char_count(s_word, strlen(s_word), NULL, NULL);

    /*ñȯ*/
    return(1);
  }
  return(0);
}

/*****************************************************************
   ʸʸΰ㤤̵뤹뤫ɤΥե饰ONޤOFF
 *****************************************************************/
int case_on_off(GtkWidget *widget, gpointer data)
{
  if (cm_ignore_case == 0) {
    cm_ignore_case = 1;
    mlwrite(IGNORE_CASE, 0);
  }
  else {
    cm_ignore_case = 0;
    mlwrite(DONT_IGNORE_CASE, 0);
  }
  return(0);
}

/**************
   
 **************/
void up_search(GtkWidget *widget, gpointer data)
{
  int res;
  long count_s;
  long count_c;
  unsigned char *s_text;
  unsigned char *s_word;
  gint pos;
  gint linenum;
  gint i;
  gint count;
  char entry_buf[256];


  count_s = 0;
  count_c = 0;
  linenum = 0;
  gtk_widget_grab_focus(current_document->textbox);

  s_word = gtk_entry_get_text(GTK_ENTRY(cm_search.entry));
  if ((s_word == NULL) || ((int)*s_word == (int)'\0')) {
    mlwrite("Input Word to Search!!", 0);
    return;
  }
  pos = gtk_editable_get_position(GTK_EDITABLE(current_document->textbox));
  s_text = gtk_editable_get_chars(GTK_EDITABLE(current_document->textbox), 0, pos);
  if (s_text == NULL) {
    mlwrite("fail to malloc...", 0);
    return;
  }
  res = search_up_dn(s_text, s_word, &count_s, &count_c, SEARCH_UP, cm_ignore_case);

  /*debug*/
  /*printf("position is %d\n", pos);
  printf("result is %d\n", res);
  printf("Ƭ %d ʸ\n", count_s);
  printf("ʸ %d ʸ\n", count_c);*/

  if (res == 1) {
    for (i = 0; i < MAX_LINE_COUNT - 1; i++) {
      if ((count_s > cm_line_count[i]) && (count_s <= cm_line_count[i + 1])) {
        linenum = i + 1;
        break;
      }
    }

    if (linenum > MAX_LINE_COUNT - 1) {
      linenum = MAX_LINE_COUNT;
    }

    if (count_s == 0) {
      linenum = 1;
    }

    /*ֹ*/
    count = linenum;

    /*ࡼʥ¸٤ linenum  10 ­Ƥ*/
    if (cm_all_lines > (linenum + 10)) {
      linenum = linenum + 10;
    }
    else {
      linenum = cm_all_lines;
    }
    scrollbar_update(GTK_TEXT(current_document->textbox), cm_all_lines, linenum);

    /*ȯʸȿž*/
    gtk_text_set_point(GTK_TEXT(current_document->textbox), count_s);
    gtk_editable_set_position(GTK_EDITABLE(current_document->textbox), count_s);
    gtk_editable_select_region(GTK_EDITABLE(current_document->textbox),
                               count_s + count_c, count_s);

    sprintf(entry_buf, "matched in line %d", count);
    mlwrite(entry_buf, 0);
    set_cur_line_number(count);
  }
  else {
    sprintf(entry_buf, "not matched (current line %d)", get_cur_line_number());
    mlwrite(entry_buf, 0);
  }

  /* ؿgtk_entry_get_textentry widgetݻƤʸ */
  /* Υݥ󥿤ϤΤǡfree()ǳưʤ */
  /*free(s_word);*/
  free(s_text);
  return;
}

/**************
   
 **************/
void dn_search(GtkWidget *widget, gpointer data)
{
  int res;
  long count_s;
  long count_c;
  unsigned char *s_text;
  unsigned char *s_word;
  gint pos;
  gint linenum;
  gint i;
  gint count;
  char entry_buf[256];


  count_s = 0;
  count_c = 0;
  linenum = 0;
  gtk_widget_grab_focus(current_document->textbox);

  s_word = gtk_entry_get_text(GTK_ENTRY(cm_search.entry));
  if ((s_word == NULL) || ((int)*s_word == (int)'\0')) {
    mlwrite("Input Word to Search!!", 0);
    return;
  }
  pos = gtk_editable_get_position(GTK_EDITABLE(current_document->textbox));
  s_text = gtk_editable_get_chars(GTK_EDITABLE(current_document->textbox), pos, -1);
  if (s_text == NULL) {
    mlwrite("fail to malloc...", 0);
    return;
  }
  res = search_up_dn(s_text, s_word, &count_s, &count_c, SEARCH_DN, cm_ignore_case);

  /*debug*/
  /*printf("position is %d\n", pos);
  printf("result is %d\n", res);
  printf("Ƭ %d ʸ\n", count_s);
  printf("ʸ %d ʸ\n", count_c);*/

  if (res == 1) {
    for (i = 0; i < MAX_LINE_COUNT - 1; i++) {
      if (((pos + count_s + 1) > cm_line_count[i]) &&
          ((pos + count_s + 1) <= cm_line_count[i + 1])) {
        linenum = i + 1;
        break;
      }
    }

    if (linenum > MAX_LINE_COUNT - 1) {
      linenum = MAX_LINE_COUNT;
    }

    if ((pos + count_s) == 0) {
      linenum = 1;
    }

    /*ֹ*/
    count = linenum;

    /*ࡼʥ¸٤ linenum  10 ­Ƥ*/
    if (cm_all_lines > (linenum + 10)) {
      linenum = linenum + 10;
    }
    else {
      linenum = cm_all_lines;
    }
    scrollbar_update(GTK_TEXT(current_document->textbox), cm_all_lines, linenum);

    /*ȯʸȿž*/
    gtk_text_set_point(GTK_TEXT(current_document->textbox), pos + count_s + 1);
    gtk_editable_set_position(GTK_EDITABLE(current_document->textbox),
                              pos + count_s + 1);
    gtk_editable_select_region(GTK_EDITABLE(current_document->textbox),
                               pos + count_s, pos + count_s + count_c);

    sprintf(entry_buf, "matched in line %d", count);
    mlwrite(entry_buf, 0);
    set_cur_line_number(count);
  }
  else {
    sprintf(entry_buf, "not matched (current line %d)", get_cur_line_number());
    mlwrite(entry_buf, 0);
  }

  /* ؿgtk_entry_get_textentry widgetݻƤʸ */
  /* Υݥ󥿤ϤΤǡfree()ǳưʤ */
  /*free(s_word);*/
  free(s_text);
  return;
}
